/*
Inbox

Inbox API can be used for low level integration and enables direct communication with you contact base.   In most cases you will use our interaction templates for communication, but our api also allows you to send message directly.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package inboxapi

import (
	"encoding/json"
)

// checks if the LocationPersonalized type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &LocationPersonalized{}

// LocationPersonalized struct for LocationPersonalized
type LocationPersonalized struct {
	Longitude string `json:"longitude"`
	Latitude string `json:"latitude"`
	Name *string `json:"name,omitempty"`
	Address *string `json:"address,omitempty"`
}

// NewLocationPersonalized instantiates a new LocationPersonalized object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewLocationPersonalized(longitude string, latitude string) *LocationPersonalized {
	this := LocationPersonalized{}
	this.Longitude = longitude
	this.Latitude = latitude
	return &this
}

// NewLocationPersonalizedWithDefaults instantiates a new LocationPersonalized object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewLocationPersonalizedWithDefaults() *LocationPersonalized {
	this := LocationPersonalized{}
	return &this
}

// GetLongitude returns the Longitude field value
func (o *LocationPersonalized) GetLongitude() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Longitude
}

// GetLongitudeOk returns a tuple with the Longitude field value
// and a boolean to check if the value has been set.
func (o *LocationPersonalized) GetLongitudeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Longitude, true
}

// SetLongitude sets field value
func (o *LocationPersonalized) SetLongitude(v string) {
	o.Longitude = v
}

// GetLatitude returns the Latitude field value
func (o *LocationPersonalized) GetLatitude() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Latitude
}

// GetLatitudeOk returns a tuple with the Latitude field value
// and a boolean to check if the value has been set.
func (o *LocationPersonalized) GetLatitudeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Latitude, true
}

// SetLatitude sets field value
func (o *LocationPersonalized) SetLatitude(v string) {
	o.Latitude = v
}

// GetName returns the Name field value if set, zero value otherwise.
func (o *LocationPersonalized) GetName() string {
	if o == nil || IsNil(o.Name) {
		var ret string
		return ret
	}
	return *o.Name
}

// GetNameOk returns a tuple with the Name field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *LocationPersonalized) GetNameOk() (*string, bool) {
	if o == nil || IsNil(o.Name) {
		return nil, false
	}
	return o.Name, true
}

// HasName returns a boolean if a field has been set.
func (o *LocationPersonalized) HasName() bool {
	if o != nil && !IsNil(o.Name) {
		return true
	}

	return false
}

// SetName gets a reference to the given string and assigns it to the Name field.
func (o *LocationPersonalized) SetName(v string) {
	o.Name = &v
}

// GetAddress returns the Address field value if set, zero value otherwise.
func (o *LocationPersonalized) GetAddress() string {
	if o == nil || IsNil(o.Address) {
		var ret string
		return ret
	}
	return *o.Address
}

// GetAddressOk returns a tuple with the Address field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *LocationPersonalized) GetAddressOk() (*string, bool) {
	if o == nil || IsNil(o.Address) {
		return nil, false
	}
	return o.Address, true
}

// HasAddress returns a boolean if a field has been set.
func (o *LocationPersonalized) HasAddress() bool {
	if o != nil && !IsNil(o.Address) {
		return true
	}

	return false
}

// SetAddress gets a reference to the given string and assigns it to the Address field.
func (o *LocationPersonalized) SetAddress(v string) {
	o.Address = &v
}

func (o LocationPersonalized) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o LocationPersonalized) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["longitude"] = o.Longitude
	toSerialize["latitude"] = o.Latitude
	if !IsNil(o.Name) {
		toSerialize["name"] = o.Name
	}
	if !IsNil(o.Address) {
		toSerialize["address"] = o.Address
	}
	return toSerialize, nil
}

type NullableLocationPersonalized struct {
	value *LocationPersonalized
	isSet bool
}

func (v NullableLocationPersonalized) Get() *LocationPersonalized {
	return v.value
}

func (v *NullableLocationPersonalized) Set(val *LocationPersonalized) {
	v.value = val
	v.isSet = true
}

func (v NullableLocationPersonalized) IsSet() bool {
	return v.isSet
}

func (v *NullableLocationPersonalized) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableLocationPersonalized(val *LocationPersonalized) *NullableLocationPersonalized {
	return &NullableLocationPersonalized{value: val, isSet: true}
}

func (v NullableLocationPersonalized) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableLocationPersonalized) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


